#include <stdio.h>
#define MAXETUD 40
#define MAXNOTES 5
typedef struct {int jour; 
		 int mois;
		 int annee;} DATE;
typedef struct {
    int numero;  char nom[30];
    char sex; DATE naiss; 
	 double notes[MAXNOTES];
	 double moyenne;} ETUDIANT;

 ETUDIANT lireEtud(void);
 void affichEtud(ETUDIANT e);
 int lireGroupe(ETUDIANT g[], int maxEtud);
 void calcMoyennes(ETUDIANT g[], int n);

  void main(void){
	 ETUDIANT groupe[MAXETUD];
	 int netud,i;
	 netud = lireGroupe(groupe, MAXETUD);
	 calcMoyennes(groupe, netud);
    printf("num       nom               date        moyenne\n");
	 for (i=0; i<netud;i++) affichEtud(groupe[i]);
  }
  ETUDIANT lireEtud(void){
	 ETUDIANT e;
	 int i,res;
	 char t[80];
	 fflush(stdin);
	 do {
		printf("Tapez le numero, le nom, et le gendre  d'etudiant separes de \',\'\n");
		gets(t);
		res = sscanf(t,"%d , %s , %c ",&e.numero,&e.nom,&t);
		if (res <3) fflush(stdin);
	 } while (res<3);
	 fflush(stdin);
	 e.sex = t[0];
	 //printf("Tapez la date de naissance dans le format \"jj/mm/yyyy\"\n");
	 do {
		puts("Tapez la date de naissance dans le format \"jj/mm/yyyy\"");
		gets(t);
		res = sscanf(t," %2d / %2d / %d ", &e.naiss.jour, &e.naiss.mois, &e.naiss.annee);
		if (res <3) fflush(stdin);
	 } while (res<3);
	 fflush(stdin);
	 printf("Tapez les %d notes d'etudiant \n", MAXNOTES);
	 for (i=0; i <MAXNOTES; i++) scanf("%lf",(e.notes+i));
	 return e;
  }

  void affichEtud(ETUDIANT e) {
	 printf ("%6d  %-15s  %2d/%2d/%4d  %5.2lf\n", e.numero,e.nom, e.naiss.jour,
			e.naiss.mois, e.naiss.annee, e.moyenne);
  }
int lit_entier_verifie(const int m, const int n){
 int x,y;
 do {
  printf ("Entrez un nombre entre %d et %d: ",m,n);
  y = scanf("%d",&x);
  if (y==EOF) {
	  x = -32000;  // erreur
	  break;
  }
  if (y!=1) {  // des symbols invalides
	  getchar();
	  putchar('\n') ;
  }
 }while (y == 0 || x < m || x > n);
 return x ;
}

  int lireGroupe(ETUDIANT g[], int maxEtud){
	int i,n;
	printf("Tapez la taille du groupe\n");
	n= lit_entier_verifie(1, maxEtud);
	for (i=0; i < n; i++){
	  printf("Tapez le donn/es pour le %d -eme etudiant\n",i+1);
	  g[i] = lireEtud();
	}
	return n;
  }
 void calcMoyennes(ETUDIANT g[], int n){
	int i,j;
	for (i=0 ; i< n; i++) {
	  g[i].moyenne = 0;
	  for (j=0; j<MAXNOTES; j++)g[i].moyenne +=g[i].notes[j];
     g[i].moyenne /= MAXNOTES;
	}
 }
